-- Colors
COL = {
	White  = pge.gfx.createcolor(255, 	255, 	255),
	Black  = pge.gfx.createcolor(0,		0,		0),
	Red    = pge.gfx.createcolor(255,	0,		0),
	Green  = pge.gfx.createcolor(0,		255,	0),
	Blue   = pge.gfx.createcolor(0,		0,		255),
	Cyan   = pge.gfx.createcolor(0,		255,	255),
	Yellow = pge.gfx.createcolor(255,	255,	0),
	Pink   = pge.gfx.createcolor(255,	135,	185),
LiDarkPink = pge.gfx.createcolor(255,	189,	255),
 LightPink = pge.gfx.createcolor(255,	230,	244),
	Violet = pge.gfx.createcolor(160,	45,		255),
LiDarkViolet = pge.gfx.createcolor(110,	5,		225),
	Skin1  = pge.gfx.createcolor(255,	215,	200),
	Skin2  = pge.gfx.createcolor(255,	195,	205),
}

-- Fonts
Sans15 = pge.font.load("Resources/Font/DTM_Sans.TTF", 15, PGE_RAM)
--Sans10 = pge.font.load("Resources/Font/DTM_Sans.TTF", 10, PGE_RAM)
RifficFree10 = pge.font.load("Resources/Font/RifficFree-Bold.ttf", 10, PGE_RAM)
RifficFree12 = pge.font.load("Resources/Font/RifficFree-Bold.ttf", 12, PGE_RAM)
RifficFree15 = pge.font.load("Resources/Font/RifficFree-Bold.ttf", 15, PGE_RAM)
Arial12 = pge.font.load("Resources/Font/Arial.ttf", 12, PGE_RAM)
Arial15B = pge.font.load("Resources/Font/ArialBold.ttf", 15, PGE_RAM)

--[[
function Screenshot()
	
	ScreenCFG = io.open("Resources/SP/SCR.ddsv", "r")
	ScreenCount = tonumber(ScreenCFG:read())
	ScreenCFG:close()
	
	screen:save("Screenshots/screenshot"..ScreenCount..".png")
	ScreenCount = ScreenCount + 1
	
	ScreenCFG = io.open("Resources/SP/SCR.ddsv", "w")
	ScreenCFG:write(ScreenCount)
	ScreenCFG:close()
	
	--fi = pgeFileOpen("", "PGE_FILE_WRONLY")
	--pgeFileWrite(fi, "LOX! PIDR!") (VAR, BUFFER, SIZE)
	--pgeFileCloseDir(fi)
	
end
--]]

-- Swap 0 - CIRCLE
-- Swap 1 - CROSS

function CheckUser()
	CFG = io.open("Resources/SP/SAVE.ddsv", "r")
	GameUsing = tonumber(CFG:read())
	CFG:close()
end

function FirstUser()
	CFG = io.open("Resources/SP/SAVE.ddsv", "w")
	CFG:write("1")
	CFG:close()
end

function ClearGameUse()
	CFG = io.open("Resources/SP/SAVE.ddsv", "w")
	CFG:write("0")
	CFG:close()
	-- Some code must be written here.
end

function MakeGamePath()
	MAIN_PATH = pge.math.randint(1,3)
	if MAIN_PATH == 1.000000 then MAIN_PATH = 1 end
	if MAIN_PATH == 2.000000 then MAIN_PATH = 2 end
	if MAIN_PATH == 3.000000 then MAIN_PATH = 3 end
	CFG = io.open("Resources/SP/YAWEVAS.ddsv", "w")
	CFG:write(MAIN_PATH)
	CFG:close()
end

-- as Default - Path = MAIN_PATH

-- ProgressFunc(1, MAIN_PATH, Dialog, Chapter)
-- ProgressFunc(2, MAIN_PATH, Dialog, Chapter)
function ProgressFunc(Command, Path, Progress, Progress2)
	-- Progress - Dialog
	-- Progress2 - Chapter
	if Command == 1 then -- Save
		if Path == 1 then
			CFG = io.open("Resources/SP/a/a1/b3.ddsv", "w")
			CFG:write(Progress)
			CFG:close()
			CFG = io.open("Resources/SP/a/a1/c2.ddsv", "w")
			CFG:write(Progress2)
			CFG:close()
		elseif Path == 2 then
			CFG = io.open("Resources/SP/a/a3/a5.ddsv", "w")
			CFG:write(Progress)
			CFG:close()
			CFG = io.open("Resources/SP/a/a2/c2.ddsv", "w")
			CFG:write(Progress2)
			CFG:close()
		elseif Path == 3 then
			CFG = io.open("Resources/SP/b/b2/a5.ddsv", "w")
			CFG:write(Progress)
			CFG:close()
			CFG = io.open("Resources/SP/b/b2/c3.ddsv", "w")
			CFG:write(Progress2)
			CFG:close()
		end
	end
	if Command == 2 then -- Load
		if Path == 1 then
			CFG = io.open("Resources/SP/a/a1/b3.ddsv", "r")
			Progress = tonumber(CFG:read())
			CFG:close()
			CFG = io.open("Resources/SP/a/a1/c2.ddsv", "r")
			Progress2 = tonumber(CFG:read())
			CFG:close()
		elseif Path == 2 then
			CFG = io.open("Resources/SP/a/a3/a5.ddsv", "r")
			Progress = tonumber(CFG:read())
			CFG:close()
			CFG = io.open("Resources/SP/a/a2/c2.ddsv", "r")
			Progress2 = tonumber(CFG:read())
			CFG:close()
		elseif Path == 3 then
			CFG = io.open("Resources/SP/b/b2/a5.ddsv", "r")
			Progress = tonumber(CFG:read())
			CFG:close()
			CFG = io.open("Resources/SP/b/b2/c3.ddsv", "r")
			Progress2 = tonumber(CFG:read())
			CFG:close()
		end
	end
end
--NameFunc(1, MAIN_PATH, Name)
function NameFunc(Command, Path, nname)
	if Command == 1 then -- Save
		if Path == 1 then
			CFG = io.open("Resources/SP/a/a1/a3.ddsv", "w")
			CFG:write(nname)
			CFG:close()
		elseif Path == 2 then
			CFG = io.open("Resources/SP/a/a2/b3.ddsv", "w")
			CFG:write(nname)
			CFG:close()
		elseif Path == 3 then
			CFG = io.open("Resources/SP/b/b1/a5.ddsv", "w")
			CFG:write(nname)
			CFG:close()
		end
	end
	if Command == 2 then -- Load
		if Path == 1 then
			CFG = io.open("Resources/SP/a/a1/a3.ddsv", "r")
			nname = tostring(CFG:read())
			CFG:close()
		elseif Path == 2 then
			CFG = io.open("Resources/SP/a/a2/b3.ddsv", "r")
			nname = tostring(CFG:read())
			CFG:close()
		elseif Path == 3 then
			CFG = io.open("Resources/SP/b/b1/a5.ddsv", "r")
			nname = tostring(CFG:read())
			CFG:close()
		end
	end
end

--[[
function LoadName()
	CFG = io.open("Resources/SP/b/b3/b4.ddsv", "r")
	Name = tostring(CFG:read())
	CFG:close()
end

function SaveName(Name)
	CFG = io.open("Resources/SP/b/b3/b4.ddsv", "w")
	CFG:write(Name)
	CFG:close()
end
--]]

--[[

We need to save only3 variables:
	Name
	Dialog
	Chapter


a = {
	a1 = {
		a1
		a2
		a3 - Name1
		a4
		a5
		
		b1
		b2
		b3 - Dialog1
		b4
		b5
		
		c1 - Chapter1
		c2
		c3
		c4
		c5
	}
	a2 = {
		a1
		a2
		a3
		a4
		a5
		
		b1
		b2
		b3 - Name2
		b4
		b5
		
		c1
		c2 - Chapter2
		c3
		c4
		c5
	}
	a3 = {
		a1
		a2
		a3
		a4
		a5 - Dialog2
		
		b1
		b2
		b3
		b4
		b5
		
		c1
		c2
		c3
		c4
		c5
	}
}

b = {
	b1 = {
		a1
		a2
		a3
		a4
		a5 - Name3
		
		b1
		b2
		b3
		b4
		b5
		
		c1
		c2
		c3
		c4
		c5
	}
	b2 = {
		a1
		a2
		a3
		a4
		a5 - Dialog3
		
		b1
		b2
		b3
		b4
		b5
		
		c1
		c2
		c3 - Chapter3
		c4
		c5
	}
	b3 = {
		a1
		a2
		a3
		a4
		a5
		
		b1
		b2
		b3
		b4
		b5
		
		c1
		c2
		c3
		c4
		c5
	}
}

c = {
	a1
	a2
	a3
	a4
	a5
	
	b1
	b2
	b3
	b4
	b5
	
	c1
	c2
	c3
	c4
	c5
}

SAVE1.ddsv -- Path Save-File (3 Paths max)
SAVE2.ddsv -- Path Analyser (Path done or not?) (1 - true, 0 - false)


--]]

--[[
=- Update v4 -= 23.05.2018 22:28
* Added a new font
* A new Position System (Better in use)
By MasterMen
--]]

---- Corners
--Position Up-Left | 100 000 000
--100
--000
--000

--Position Up-Right | 001 000 000
--001
--000
--000

--Position Down-Left | 000 000 100
--000
--000
--100

--Position Down-Right | 000 000 001
--000
--000
--001

----------------

-- Position Up | 010 000 000
--010
--000
--000

-- Position Down | 000 000 010
--000
--000
--010

-- Position Left | 000 100 000
--000
--100
--000

-- Position Right | 000 001 000
--000
--001
--000

-- Position Top | 000 010 000
--000
--010
--000

--[[

-- Engine's OutText v4
function OutText(FontName1,FontName2,X,Y,Color1,Color2,Text2Range,Text,Pos1,Pos2,Pos3)
	-- Text2Range as Default == 2
	function PosZero()
		-- Function Clears nil values
		Pos1 = "000"
		Pos2 = "000"
		Pos3 = "000"
		Text2Range = nil
		Color2 = nil
	end
	
	if Color2 == nil and Text2Range == nil then PosZero() end
	if Color2 == nil or Text2Range == nil then PosZero() end
	
	--if Position ~= 1 and Position ~= 2 and Position ~= 3 and Position ~= 4 and Position ~= 13 and Position ~= 14 and Position ~= 23 and Position ~= 24 and Position ~= 0 then
	--	PosZero()
	--end
	
	if Pos1 == "000" and Pos2 == "000" and Pos3 == "000" then
		Pos1 = "000"
		Pos2 = "010"
		Pos3 = "000"
	end
	
	if Pos1 == "000" and Pos2 == "010" and Pos3 == "000" then
		FontName2:activate()
		FontName2:print(X,Y,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	
	if Pos1 == "100" and Pos2 == "000" and Pos3 == "000" then
		FontName2:activate()
		FontName2:print(X - Text2Range,Y - Text2Range,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	if Pos1 == "001" and Pos2 == "000" and Pos3 == "000" then
		FontName2:activate()
		FontName2:print(X + Text2Range,Y - Text2Range,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	if Pos1 == "000" and Pos2 == "000" and Pos3 == "100" then
		FontName2:activate()
		FontName2:print(X - Text2Range,Y + Text2Range,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	if Pos1 == "000" and Pos2 == "000" and Pos3 == "001" then
		FontName2:activate()
		FontName2:print(X + Text2Range,Y + Text2Range,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	
	if Pos1 == "010" and Pos2 == "000" and Pos3 == "000" then
		FontName2:activate()
		FontName2:print(X,Y - Text2Range,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	if Pos1 == "000" and Pos2 == "000" and Pos3 == "010" then
		FontName2:activate()
		FontName2:print(X,Y + Text2Range,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	if Pos1 == "000" and Pos2 == "100" and Pos3 == "000" then
		FontName2:activate()
		FontName2:print(X - Text2Range,Y,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	if Pos1 == "000" and Pos2 == "001" and Pos3 == "000" then
		FontName2:activate()
		FontName2:print(X + Text2Range,Y,Color2,Text)
		FontName1:activate()
		FontName1:print(X,Y,Color1,Text)
	end
	-- End Function
end

--]]